package ReproduceBioTransformerResults;

import java.io.File;
import java.io.FileWriter;

import org.openscience.cdk.DefaultChemObjectBuilder;
import org.openscience.cdk.inchi.InChIGenerator;
import org.openscience.cdk.inchi.InChIGeneratorFactory;
import org.openscience.cdk.interfaces.IAtomContainer;
import org.openscience.cdk.interfaces.IAtomContainerSet;
import org.openscience.cdk.smiles.SmiFlavor;
import org.openscience.cdk.smiles.SmilesGenerator;

import createSomDataset.CollectData_convertSMIRKS_to_SDF;

public class RunVersion105 {
	SmilesGenerator sg = new SmilesGenerator(SmiFlavor.Isomeric);
	CollectData_convertSMIRKS_to_SDF cd = new CollectData_convertSMIRKS_to_SDF();
	public static void main(String[] args) throws Exception{
		String inputPath_test = "G:/PhaseIIPredictor/UGT/withNS/UGT_test.sdf";
		RunVersion105 rv = new RunVersion105();		
		//IAtomContainerSet molecules = rv.cd.readSDFFile(inputPath_test);
		//rv.generateBatFile(molecules,"UGT");
		
		String inputPath_test_SULT = "G:/PhaseIIPredictor/Sulfation/withNS/Sulfation_test.sdf";
		IAtomContainerSet molecules = rv.cd.readSDFFile(inputPath_test_SULT);
		rv.generateBatFile(molecules,"SULT");
	
	}
	
	
	public void generateBatFile(IAtomContainerSet molecules, String type) throws Exception{
		String outputPath;
		if(type.equals("UGT")) {
			outputPath = "E:/Users/Tian/git/biotransformerjar/PhaseII/UGT_test_script.txt";
		}
		else outputPath = "E:/Users/Tian/git/biotransformerjar/PhaseII/SULT_test_script.txt";
		FileWriter fw = new FileWriter(new File(outputPath));
		InChIGeneratorFactory inchiFact = InChIGeneratorFactory.getInstance();
		String oneCommandLine;
		for(int i = 0; i < molecules.getAtomContainerCount(); i++) {
			IAtomContainer oneMole = molecules.getAtomContainer(i);
			InChIGenerator inchiGen = inchiFact.getInChIGenerator(oneMole);
			String name = inchiGen.getInchiKey();
			String smiles = this.sg.create(oneMole);
			oneCommandLine = "java -jar biotransformer-1-0-5.jar -k pred -b phaseII -f smiles -i " + smiles +  " -o "  + 
					"E:/Users/Tian/git/biotransformerjar/PhaseII/test/" + name + ".sdf";
			fw.write(oneCommandLine + "\n");
		}
		fw.close();
	}
}
