package WhateverRandomThings;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;

import org.openscience.cdk.DefaultChemObjectBuilder;
import org.openscience.cdk.interfaces.IAtomContainer;
import org.openscience.cdk.interfaces.IMolecularFormula;
import org.openscience.cdk.smiles.SmilesParser;
import org.openscience.cdk.tools.manipulator.MolecularFormulaManipulator;

public class CreateDataForHMDB {
	SmilesParser sp  = new SmilesParser(DefaultChemObjectBuilder.getInstance());
	public static void main(String[] args) throws Exception{
		String inputPath = "G:/Biology/Retip_RT/HMDB/hmdb_prediction_rt.tsv";
		String outputPath = "G:/Biology/Retip_RT/HMDB/";
		CreateDataForHMDB cdf = new CreateDataForHMDB();
		//cdf.generateDataForRetip(inputPath, outputPath);
		//cdf.mergeResultDataForRetip();
		cdf.findNotIncludedDataForRetip();
	}
	
	public void findNotIncludedDataForRetip() throws Exception{
		String inputPath_1 =  "G:/Biology/Retip_RT/HMDB/ExcelResults_tsv/merged_result.tsv";
		String inputPath_2 = "G:/Biology/Retip_RT/HMDB/hmdb_prediction_rt.tsv";
		String outputPath = "G:/Biology/Retip_RT/HMDB/notIncluded_inRetip.tsv";
		FileWriter fw = new FileWriter(new File(outputPath));
		BufferedReader br = new BufferedReader(new FileReader(new File(inputPath_1)));
		ArrayList<String> inchiKey_used = new ArrayList<>();
		String oneLine = br.readLine();//title line
		String inChIKey;
		while((oneLine = br.readLine()) != null){
			inChIKey = oneLine.split("\t")[1];
			if(!inchiKey_used.contains(inChIKey)) inchiKey_used.add(inChIKey);
		}
		br.close();
		br = new BufferedReader(new FileReader(new File(inputPath_2)));
		oneLine = br.readLine();//title line
		fw.write(oneLine + "\n");
		while((oneLine = br.readLine()) != null) {
			inChIKey = oneLine.split("\t")[3];
			if(!inchiKey_used.contains(inChIKey)) fw.write(oneLine + "\n");
		}
		br.close();
		fw.close();
	}
	
	public void mergeResultDataForRetip() throws Exception{
		ArrayList<String> inchiKeyList = new ArrayList<>();
		String inputPath_Folder = "G:/Biology/Retip_RT/HMDB/ExcelResults_tsv/";
		String outputPath = "G:/Biology/Retip_RT/HMDB/ExcelResults_tsv/merged_result.tsv";
		File folder = new File(inputPath_Folder);
		File[] file_list = folder.listFiles();
		FileWriter fw = new FileWriter(new File(outputPath));
		fw.write("Name\tInChIKey\tSMILES\tRTP\n");
		for(int i = 0; i < file_list.length; i++) {
			File oneFile = file_list[i];
			BufferedReader br = new BufferedReader(new FileReader(oneFile));
			String oneLine = br.readLine();//title line
			while((oneLine = br.readLine()) != null) {
				String[] parseLine = oneLine.split("\t");
				String name = parseLine[0];
				String inchIKey = parseLine[1];
				if(!inchiKeyList.contains(inchIKey)) inchiKeyList.add(inchIKey);
				else continue;
				String smiles = parseLine[2];
				String rt = parseLine[3];
				//Double rt_new = Double.parseDouble(parseLine[3])*60;
				fw.write(name + "\t" + inchIKey + "\t" + smiles + "\t" + rt + "\n");
				
			}
			br.close();
		}
		fw.close();
	}
	public void generateDataForRetip(String inputPath, String outputPath) throws Exception{
		FileWriter fw = null;
		BufferedReader br = new BufferedReader(new FileReader(new File(inputPath)));
		String oneLine = br.readLine(); //title line
		int counter = -1;
		while((oneLine = br.readLine()) != null) {
			counter++;
			String name = oneLine.split("\t")[1];
			String inChIKey = oneLine.split("\t")[3];
			String smiles = oneLine.split("\t")[2];
			if( (((counter - (counter % 10000)) / 10000) + 1) < 17) continue;
				
			
			if(counter > 240000) {
				System.out.println(smiles);
			}
			if(counter % 10000 == 0) {
				if(fw!=null) fw.close();
				String newPartPath = outputPath + "training_part_" + (((counter - (counter % 10000)) / 10000) + 1) + ".tsv";
				fw = new FileWriter(new File(newPartPath));
				fw.write("Name" + "\t" + "InChIKey" + "\t" + "SMILES" + "\n");
			}
			IAtomContainer oneMole = this.sp.parseSmiles(smiles);
			IMolecularFormula formula = MolecularFormulaManipulator.getMolecularFormula(oneMole);	
			if(MolecularFormulaManipulator.getMass(formula) > 1500) continue;
			fw.write(name + "\t" + inChIKey + "\t" + smiles + "\n");
		}
		fw.close();
		
	}
}
