package WhateverRandomThings;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

import org.openscience.cdk.DefaultChemObjectBuilder;
import org.openscience.cdk.inchi.InChIGenerator;
import org.openscience.cdk.inchi.InChIGeneratorFactory;
import org.openscience.cdk.inchi.InChIToStructure;
import org.openscience.cdk.interfaces.IAtomContainer;
import org.openscience.cdk.smiles.SmiFlavor;
import org.openscience.cdk.smiles.SmilesGenerator;

public class HandleMetlin {
	public static void main(String[] args) throws Exception{
		String inputPath = "G:/Biology/Retip_RT/MetlinTrain/Training.tsv";
		String outputPath = "G:/Biology/Retip_RT/MetlinTrain/";
		HandleMetlin hm = new HandleMetlin();
		hm.converInChIFileToSMILES(inputPath, outputPath);
	}
	
	public void converInChIFileToSMILES(String inputPath, String outputPath) throws Exception{
		FileWriter fw = null;
		InChIGeneratorFactory inchiFac = InChIGeneratorFactory.getInstance();
		SmilesGenerator sg = new SmilesGenerator(SmiFlavor.Isomeric);
		BufferedReader br = new BufferedReader(new FileReader(new File(inputPath)));
		String oneLine = br.readLine();//Title lin
		int counter = 0;
		while((oneLine = br.readLine()) != null) {	
			//if( counter > 25000) break;
			if(counter % 10000 == 0) {
				if(fw!=null) fw.close();
				String newPartPath = outputPath + "training_part_" + (((counter - (counter % 10000)) / 10000) + 1) + ".tsv";
				fw = new FileWriter(new File(newPartPath));
				fw.write("Name" + "\t" + "InChIKey" + "\t" + "SMILES" + "\t" + "RT" + "\n");
			}
			counter++;
			String pubchemID = oneLine.split(";")[0].replace("\"", "");
			String rt = oneLine.split(";")[1].replace("\"", "");
			String inchi = oneLine.split(";")[2].replace("\"", "");
			InChIToStructure inchiToStruct = inchiFac.getInChIToStructure(inchi, DefaultChemObjectBuilder.getInstance());
			IAtomContainer oneMole = inchiToStruct.getAtomContainer();
			String smiles = sg.create(oneMole);
			InChIGenerator inchiGen = inchiFac.getInChIGenerator(oneMole);
			String inChIKey = inchiGen.getInchiKey();
			fw.write("PubChem_" + pubchemID + "\t" + inChIKey + "\t" + smiles + "\t" + rt + "\n");
		}
		fw.close();
	}
}
