package WhateverRandomThings;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;

import org.openscience.cdk.interfaces.IAtomContainer;
import org.openscience.cdk.interfaces.IAtomContainerSet;

import createSomDataset.CollectData_convertSMIRKS_to_SDF;
import generateInstance.GenerateInstances;
import generateInstance.GenerateRawFeatures;
import phase2utils.GenerateTitleline;
import weka.classifiers.Classifier;
import weka.core.Attribute;
import weka.core.DenseInstance;
import weka.core.Instance;
import weka.core.Instances;

public class testModel {
	int depth = 4;
	GenerateInstances generateInstances = new GenerateInstances(depth);
	GenerateRawFeatures generateRawFeatures = new GenerateRawFeatures(depth);
	CollectData_convertSMIRKS_to_SDF cd = new CollectData_convertSMIRKS_to_SDF();
	public static void main(String[] args) throws Exception{
		testModel tm = new testModel();
		//tm.testLoadedModel();
		tm.testModel_SULF();
		//tm.testUGT();
	}
	
	public void testUGT() throws Exception{
		String inputPath_test = "G:/PhaseIIPredictor/UGT/withNS/UGT_test.sdf";
		Classifier cls = (Classifier) weka.core.SerializationHelper.read("G:/PhaseIIPredictor/UGT/withNS/UGT.model");
		IAtomContainerSet molecules = this.cd.readSDFFile(inputPath_test);
		ArrayList<String> attList = getAttList("UGT");
		int TP = 0, FP = 0, TN = 0, FN = 0;
		for(int t = 0; t < molecules.getAtomContainerCount(); t++) {
			Instances allInstances = getInstances(molecules.getAtomContainer(t));
			Instances matchedInstances = matchAttributes(allInstances, attList);	
			for(int i = 0; i < allInstances.numInstances(); i++) {
				double result = allInstances.get(i).classValue();
				String atom_idx = allInstances.attribute("Bond").value(i);		
				Instance oneInstance = matchedInstances.get(i);
				double prob  = cls.distributionForInstance(oneInstance)[1];
				double pred = 0.0;
				if(prob >= 0.3) {
					//System.out.println(allInstances.attribute("Name").value(0));
					System.out.println("Molecule idx: " + t + " ; reactive site: " + atom_idx);
					System.out.println(atom_idx + ": " + prob);
					pred = 1.0;
				}
				if(result == pred) {
					if(result == 1.0) TP++;
					else TN++;
				}
				else {
					if(result == 1.0) {
						FN++;
					}
					else FP++;
				}
			}
		}
		System.out.println("   P		N");
		System.out.println("P " + TP + "	   " + FN);
		System.out.println("N " + FP + "	   " + TN);
	}
	public void testModel_SULF() throws Exception{
		String inputPath_valid = "G:/PhaseIIPredictor/Sulfation/withNS/Sulfation_validation.sdf";
		Classifier cls = (Classifier) weka.core.SerializationHelper.read("G:/PhaseIIPredictor/Sulfation/withNS/SULF.model");
		IAtomContainerSet molecules = this.cd.readSDFFile(inputPath_valid);
		ArrayList<String> attList = getAttList("SULF");
		int TP = 0, FP = 0, TN = 0, FN = 0;
		for(int t = 0; t < molecules.getAtomContainerCount(); t++) {
			Instances allInstances = getInstances(molecules.getAtomContainer(t));
			Instances matchedInstances = matchAttributes(allInstances, attList);	
			for(int i = 0; i < allInstances.numInstances(); i++) {
				double result = allInstances.get(i).classValue();
				String atom_idx = allInstances.attribute("Bond").value(i);		
				Instance oneInstance = matchedInstances.get(i);
				double prob  = cls.distributionForInstance(oneInstance)[1];
				double pred = 0.0;
				if(prob >= 0.3) {
					System.out.println(allInstances.attribute("Name").value(0));
					System.out.println("Molecule idx: " + t + " ; reactive site: " + atom_idx);
					System.out.println(atom_idx + ": " + prob);
					pred = 1.0;
				}
				if(result == pred) {
					if(result == 1.0) TP++;
					else TN++;
				}
				else {
					if(result == 1.0) {
						FN++;
					}
					else FP++;
				}
			}
		}
		System.out.println("   P		N");
		System.out.println("P " + TP + "	   " + FN);
		System.out.println("N " + FP + "	   " + TN);

	}
	
	
	public void testLoadedModel() throws Exception{
		String inputPath_test = "G:/PhaseIIPredictor/UGT/withNS/UGT_test.sdf";
		IAtomContainerSet molecules_test = 	this.cd.readSDFFile(inputPath_test);
		Classifier cls = (Classifier) weka.core.SerializationHelper.read("G:/PhaseIIPredictor/UGT/withNS/UGT.model");
		ArrayList<String> attList = getAttList("UGT");
		for(int t = 0; t < molecules_test.getAtomContainerCount(); t++) {
			Instances allInstances = getInstances(molecules_test.getAtomContainer(t));
			Instances matchedInstances = matchAttributes(allInstances, attList);
			for(int i = 0; i < allInstances.numInstances(); i++) {
				String atom_idx = allInstances.attribute("Bond").value(i);		
				Instance oneInstance = matchedInstances.get(i);
				double prob  = cls.distributionForInstance(oneInstance)[1];
				if(prob > 0.3) {
					System.out.println(allInstances.attribute("Name").value(0));
					System.out.println(atom_idx + ": " + prob);
				}
			}
		}
	}
	
	public Instances matchAttributes(Instances testSet, ArrayList<String> attListToMatch) throws Exception{
		/*
		 * Create the class atrribute
		 */
		ArrayList<String> my_nominal_values = new ArrayList<>(); 
		my_nominal_values.add("F"); 
		my_nominal_values.add("T"); 
		Attribute lastAttribute  = new Attribute(attListToMatch.get(attListToMatch.size()-1), my_nominal_values);
		/*
		 * Convert the attribute name strings to attribute
		 */
		ArrayList<Attribute> attsToMatch = new ArrayList<Attribute>();
		for(int i = 0; i<attListToMatch.size();i++){
			if(i<attListToMatch.size()-1){
				Attribute attribute = new Attribute(attListToMatch.get(i));
				attsToMatch.add(attribute);
			}
			else{				
				attsToMatch.add(lastAttribute);
			}
		}

		int numAttributes = attListToMatch.size();
		Instances matched = new Instances("Rel", attsToMatch, testSet.size());
		Instance sample = new DenseInstance(numAttributes);
		/*
		 * Assign values for each testing instance
		 */
		for(int idxInstance = 0; idxInstance< testSet.size(); idxInstance++){
			//ArrayList misFeatures = new ArrayList();
			Instance temp = testSet.get(idxInstance);
			String label;
			//System.out.println("Check Predictor temp.classValue() == " + temp.classValue());
			if(temp.classValue()==0.0){
				label = "F";
			}
			else{
				label = "T";
			}
			
			for(int idxAttribute = 0; idxAttribute < numAttributes; idxAttribute++){
				  Attribute oneAttribute = attsToMatch.get(idxAttribute);
				  if(idxAttribute<numAttributes-1){					  
					  String nameOfAtt = oneAttribute.toString();
					  String[] formatAtt = nameOfAtt.split(" ");
					  
					  if(formatAtt.length!=3){
						  String combineSpaces = "";
						  for(int kk = 1; kk<formatAtt.length-1; kk++){
							  if(kk<formatAtt.length - 2){
								  combineSpaces = combineSpaces + formatAtt[kk]+ " ";
							  }
							  else combineSpaces = combineSpaces + formatAtt[kk];
						  }
						  formatAtt[1] = combineSpaces;
					  }
					 
					  if(formatAtt[1].contains("'")){
						  formatAtt[1] = formatAtt[1].replace("'", "");
					  }
					  //System.out.println(formatAtt[1]);
					  Attribute convAtt = testSet.attribute(formatAtt[1]);
					  double vle = temp.value(convAtt);
					  if(!Double.isNaN(vle)){					
						  sample.setValue(oneAttribute, vle);
					  }

				  }
				  else{
					  //Set class with random value. Does not matter
					  sample.setValue(lastAttribute, label);
					  
				  }
			}						
			matched.add(sample);
		}
		if(matched.classIndex() == -1){
			matched.setClassIndex(matched.numAttributes()-1);
		}
		
		return matched;
		
	}
	
	public Instances getInstances(IAtomContainer oneMole) throws Exception{
		String titleLine = GenerateTitleline.generateTitle(this.depth);	
		ArrayList<Attribute> attList = this.generateInstances.createAttributes(titleLine);		
		ArrayList<String> rawDataList = new ArrayList<>();
		Instances bomInstances = new Instances("Rel", attList, 100000); 
		ArrayList<String> rawFeatureList = new ArrayList<>();
		try {
			rawFeatureList = this.generateRawFeatures.generateRawFeatures(oneMole);
			}catch (Exception e) 
		{
				//e.printStackTrace();				
				System.out.println("Failed processing molecule : " + this.cd.sg.create(oneMole));
				IAtomContainer converted = this.cd.processNitrogen(oneMole);
				if(converted == null || converted.isEmpty()) System.out.println("Failed to convert the nitrogen contained functional group");
				else{
					System.out.println("Converted: " + this.cd.sg.create(converted));
					try {
						rawFeatureList = this.generateRawFeatures.generateRawFeatures(converted);		
					}catch(Exception e2) {
						System.out.println("Failed to generate raw features for the converted structure");
					}
				}
			
							
		}
		rawDataList.addAll(rawFeatureList);	
		bomInstances = this.generateInstances.createInstances(rawDataList, titleLine);
		return bomInstances;
	}
	public ArrayList<String> getAttList(String type) throws Exception{
		ArrayList<String> attList = new ArrayList<>();
		if(type.equals("UGT")) {
			String inputPath = "G:/PhaseIIPredictor/UGT/withNS/UGT_supportfiles.csv";
			BufferedReader br = new BufferedReader(new FileReader(new File(inputPath)));
			String oneLine = br.readLine();//skip threshold line
			while((oneLine = br.readLine()) != null) {
				attList.add(oneLine);
			}
			br.close();
		}
		else {
			String inputPath = "G:/PhaseIIPredictor/Sulfation/withNS/SULF_supportfiles.csv";
			BufferedReader br = new BufferedReader(new FileReader(new File(inputPath)));
			String oneLine = br.readLine();//skip threshold line
			while((oneLine = br.readLine()) != null) {
				attList.add(oneLine);
			}
			br.close();
		}
		return attList;
	}

}
