package compareDataset;

import java.util.ArrayList;

import org.openscience.cdk.DefaultChemObjectBuilder;
import org.openscience.cdk.inchi.InChIGenerator;
import org.openscience.cdk.inchi.InChIGeneratorFactory;
import org.openscience.cdk.interfaces.IAtomContainer;
import org.openscience.cdk.interfaces.IAtomContainerSet;

import createSomDataset.CollectData_convertSMIRKS_to_SDF;

public class CompareTwoDatasets {
	CollectData_convertSMIRKS_to_SDF cd = new CollectData_convertSMIRKS_to_SDF();
	public static void main(String[] args) throws Exception{
		String inputPath_setOne_part1 = "G:/PhaseIIPredictor/Training.sdf";
		String inputPath_setOne_part2 = "G:/PhaseIIPredictor/Validation.sdf";
		String inputPath_setTwo = "G:/PhaseIIPredictor/Peng_external_dataset.sdf";
		String outputPath_uniqueOutput = "G:/PhaseIIPredictor/FromPeng_and_not_in_trainOrvalidate_dataset.sdf";
		CompareTwoDatasets ctd = new CompareTwoDatasets();
		IAtomContainerSet setOne = ctd.generateSetOne(inputPath_setOne_part1, inputPath_setOne_part2);
		IAtomContainerSet setTwo = ctd.cd.readSDFFile(inputPath_setTwo);
		ctd.cd.writeSDF(ctd.compareTwoDatasets(setOne, setTwo), outputPath_uniqueOutput);
		
	}
	
	public IAtomContainerSet compareTwoDatasets(IAtomContainerSet setOne, IAtomContainerSet setTwo) throws Exception{
		IAtomContainerSet moleculesSetTwo_notInSetOne = DefaultChemObjectBuilder.getInstance().newInstance(IAtomContainerSet.class);
		ArrayList<String> inchiKey_14_list_setOne = generateInChIKey14List(setOne);
		ArrayList<String> inchiKey_14_list_setTwo = generateInChIKey14List(setTwo);
		int countDupliacte = 0, notInSetOne = 0;
		for(int i = 0; i < inchiKey_14_list_setTwo.size(); i++) {
			if(inchiKey_14_list_setOne.contains(inchiKey_14_list_setTwo.get(i))) {
				countDupliacte++;
			}
			else {
				notInSetOne++;
				moleculesSetTwo_notInSetOne.addAtomContainer(setTwo.getAtomContainer(i));
			}
		}
		System.out.println(String.format("Duplicate molecules: %s, uniqueMolecules in setTwo: %s", countDupliacte, notInSetOne));
		return moleculesSetTwo_notInSetOne;
	}
	
	public ArrayList<String> generateInChIKey14List(IAtomContainerSet molecules) throws Exception{
		ArrayList<String> inchikey_14_list = new ArrayList<>();
		for(int i = 0; i < molecules.getAtomContainerCount(); i++) {
			IAtomContainer oneMole = molecules.getAtomContainer(i);
			InChIGeneratorFactory inchiGenFactory = InChIGeneratorFactory.getInstance();
			InChIGenerator inChIgen = inchiGenFactory.getInChIGenerator(oneMole);
			String inChIKey_14 = inChIgen.getInchiKey().split("-")[0];
			if(!inchikey_14_list.contains(inChIKey_14)) inchikey_14_list.add(inChIKey_14);
			
		}
		return inchikey_14_list;
	}
	
	public IAtomContainerSet generateSetOne(String inputPath_setOne_part1, String inputPath_setOne_part2) throws Exception{
		IAtomContainerSet setOne = this.cd.readSDFFile(inputPath_setOne_part1);
		setOne.add(this.cd.readSDFFile(inputPath_setOne_part2));
		return setOne;
		
		
	}
}
