package createSomDataset;

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;

import org.openscience.cdk.interfaces.IAtomContainerSet;

import generateInstance.GenerateInstances;
import generateInstance.GenerateRawFeatures;
import phase2utils.Utilities;
import weka.classifiers.trees.RandomForest;
import weka.core.Instances;

public class Trainmodel {
	CollectData_convertSMIRKS_to_SDF cd = new CollectData_convertSMIRKS_to_SDF();
	int depth = 4;
	int numFolders = 5;
	GenerateRawFeatures generateFeatures = new GenerateRawFeatures(depth);
	GenerateInstances generateInstances = new GenerateInstances(depth);
	PrepareCV pc = new PrepareCV();

	int[] thresholdSet = {50, 80, 110, -1};//{30, 60, 90, 150, -1};
	public static void main(String[] args) throws Exception{
		//String inputPath = "G:/PhaseIIPredictor/Training.sdf";
		//String outputPath = "G:/PhaseIIPredictor/Training.arff";
		String inputPath_nameArff = "G:/PhaseIIPredictor/TrainingData/nameList.arff";
		String inputPath_allFeatures = "G:/PhaseIIPredictor/TrainingData/trainingFeatures.csv";
		Trainmodel tm = new Trainmodel();
		Instances nameInstances = tm.pc.readArffFile(inputPath_nameArff);
		Instances allInstances = tm.pc.readCsv(inputPath_allFeatures);
		tm.external(nameInstances, allInstances, 150);
		
	}
	

	public void external(Instances nameInstances, Instances allInstances, int threshold) throws Exception{
		String outputPath = "G:/PhaseIIPredictor/TrainingData/checkFN.csv";
		FileWriter fw = new FileWriter(new File(outputPath));
		fw.write("name,bond,prob\n");
		nameInstances.stratify(this.numFolders);
		int TP = 0, FP = 0, TN = 0, FN = 0;
		for(int i = 0; i < this.numFolders; i++) {
			Instances trainingNames = nameInstances.trainCV(this.numFolders, i);
			Instances testNames = nameInstances.testCV(this.numFolders, i);
			Instances trainingData = this.pc.getInstancesByName(trainingNames, allInstances);
			Instances testingData = this.pc.getInstancesByName(testNames, allInstances);
			Instances trainingData_noNameBond = Utilities.selectByInfoGain(this.pc.getDatasetWithoutNameBond(trainingData), threshold);
			
			Instances testingData_noNameBond = this.pc.getSameAttributes(testingData, trainingData_noNameBond);
			RandomForest rf = new RandomForest();
			//String[] paraSet = parameters.split(",");
			int bachPercent = 95;
			rf.setBagSizePercent(bachPercent);
			rf.buildClassifier(trainingData_noNameBond);
			for(int j = 0; j < testingData_noNameBond.size(); j++) {
				double result = testingData_noNameBond.get(j).classValue();
				//double pred = rf.classifyInstance(testingData_noNameBond.get(j));
				double prob = rf.distributionForInstance(testingData_noNameBond.get(j))[1];
				double pred = 0.0;
				if(prob >= 0.35) pred = 1.0;
				if(result == pred) {
					if(result == 1.0) TP++;
					else TN++;
				}
				else {
					if(result == 1.0) {
						fw.write(testingData.instance(j).stringValue(0) + "," + testingData.instance(j).stringValue(1) + "," + prob + "\n");
						FN++;
					}
					else FP++;
				}
			}
			System.out.println("Finished Fold: " + (i + 1));
			
		}
		fw.close();
		System.out.println("   P		N");
		System.out.println("P " + TP + "	   " + FN);
		System.out.println("N " + FP + "	   " + TN);
	}
	
	
	
	
	
	
	
	
	
	

}
