package createSomDataset;

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

import org.openscience.cdk.interfaces.IAtomContainer;
import org.openscience.cdk.interfaces.IAtomContainerSet;

import generateInstance.GenerateInstances;
import generateInstance.GenerateRawFeatures;
import phase2utils.GenerateTitleline;
import phase2utils.Utilities;
import weka.classifiers.Classifier;
import weka.classifiers.trees.RandomForest;
import weka.core.Attribute;
import weka.core.DenseInstance;
import weka.core.Instance;
import weka.core.Instances;

public class ValidateAndTestModel {
	PrepareCV pc = new PrepareCV();	
	int depth = 4;
	GenerateInstances generateInstances = new GenerateInstances(depth);
	GenerateRawFeatures generateRawFeatures = new GenerateRawFeatures(depth);
	CollectData_convertSMIRKS_to_SDF cd = new CollectData_convertSMIRKS_to_SDF();
	public static void main(String[] args) throws Exception{
		String inputPath_allFeatures = "G:/PhaseIIPredictor/UGT/TrainingData/trainingFeatures.csv";
		String input_sdfPath = "G:/PhaseIIPredictor/UGT/withNS/UGT_validation.sdf";
		String test_sdfPath = "G:/PhaseIIPredictor/UGT/withNS/UGT_test.sdf";
		//String test_sdfPath = "G:/PhaseIIPredictor/UGT/FromPeng_and_not_in_trainOrvalidate_dataset.sdf";
		//String test_sdfPath = "G:/PhaseIIPredictor/UGT/suppl_info/35_difficult_molecules/35Diffuclt.sdf";
		ValidateAndTestModel vm = new ValidateAndTestModel();
		//Instances nameInstances = tm.pc.readArffFile(inputPath_nameArff);
		//Instances allInstances = vm.pc.readCsv(inputPath_allFeatures);
		//vm.validate(allInstances, 150);
		//vm.validate(inputPath_allFeatures, input_sdfPath);
		//vm.test(inputPath_allFeatures, input_sdfPath, test_sdfPath);
		
		//vm.validate_SULT();
		//vm.test_SULT();
		
		vm.generateModelRelevantFiles_UGT();
		//vm.generateModelRelevantFiles_SULF();
	}
	
	public void generateModelRelevantFiles_SULF() throws Exception{
		String inputPath_train = "G:/PhaseIIPredictor/Sulfation/withNS/Sulfation_training.sdf";
		String inputPath_valid = "G:/PhaseIIPredictor/Sulfation/withNS/Sulfation_validation.sdf";
		String inputPath_test = "G:/PhaseIIPredictor/Sulfation/withNS/Sulfation_test.sdf";
		String outputPath_attributes = "G:/PhaseIIPredictor/Sulfation/withNS/SULF_supportfiles.csv";
		IAtomContainerSet molecules_train = 	this.cd.readSDFFile(inputPath_train);
		IAtomContainerSet molecules_valid = 	this.cd.readSDFFile(inputPath_valid);
		IAtomContainerSet molecules_test = 	this.cd.readSDFFile(inputPath_test);
		Instances allInstances = getInstances(molecules_train);
		allInstances.addAll(getInstances(molecules_valid));
		allInstances.addAll(getInstances(molecules_test));
		int bachPercent = 80;
		int threshold = 70;
		Instances trainingData_noNameBond = Utilities.selectByInfoGain(this.pc.getDatasetWithoutNameBond(allInstances), threshold);	
		int TP = 0, FP = 0, TN = 0, FN = 0;
		RandomForest rf = new RandomForest();		
		rf.setBagSizePercent(bachPercent);
		rf.buildClassifier(trainingData_noNameBond);
		weka.core.SerializationHelper.write("G:/PhaseIIPredictor/Sulfation/withNS/SULF.model", rf);
		FileWriter fw = new FileWriter(new File(outputPath_attributes));
		fw.write(String.valueOf(0.30) + "\n");
		for( int i = 0; i < trainingData_noNameBond.numAttributes(); i++) {
			Attribute oneAttribute = trainingData_noNameBond.attribute(i);
			fw.write(oneAttribute.name() + "\n");
		}
		fw.close();
		Instances test_raw = getInstances(molecules_valid);
		Instances test = this.pc.getSameAttributes(test_raw, trainingData_noNameBond);
		for(int j = 0; j < test.numInstances(); j++) {
			//System.out.println();
			double result = test.get(j).classValue();
			//double pred = rf.classifyInstance(testingData_noNameBond.get(j));
			double prob = rf.distributionForInstance(test.get(j))[1];
			double pred = 0.0;
			if(prob >= 0.30) pred = 1.0;
			if(result == pred) {
				if(result == 1.0) TP++;
				else TN++;
			}
			else {
				if(result == 1.0) {
					FN++;
				}
				else FP++;
			}
		}
		System.out.println("   P		N");
		System.out.println("P " + TP + "	   " + FN);
		System.out.println("N " + FP + "	   " + TN);
	}

	public void generateModelRelevantFiles_UGT() throws Exception{
		String inputPath_train = "G:/PhaseIIPredictor/UGT/withNS/UGT_training.sdf";
		String inputPath_valid = "G:/PhaseIIPredictor/UGT/withNS/UGT_validation.sdf";
		String inputPath_test = "G:/PhaseIIPredictor/UGT/withNS/UGT_test.sdf";
		String outputPath_attributes = "G:/PhaseIIPredictor/UGT/withNS/UGT_supportfiles.csv";
		IAtomContainerSet molecules_train = 	this.cd.readSDFFile(inputPath_train);
		IAtomContainerSet molecules_valid = 	this.cd.readSDFFile(inputPath_valid);
		IAtomContainerSet molecules_test = 	this.cd.readSDFFile(inputPath_test);
		Instances allInstances = getInstances(molecules_train);
		allInstances.addAll(getInstances(molecules_valid));
		allInstances.addAll(getInstances(molecules_test));
		int bachPercent = 80;
		int threshold = 70;
		Instances trainingData_noNameBond = Utilities.selectByInfoGain(this.pc.getDatasetWithoutNameBond(allInstances), threshold);	
		int TP = 0, FP = 0, TN = 0, FN = 0;
		RandomForest rf = new RandomForest();		
		rf.setBagSizePercent(bachPercent);
		rf.buildClassifier(trainingData_noNameBond);
		weka.core.SerializationHelper.write("G:/PhaseIIPredictor/UGT/withNS/UGT.model", rf);
		FileWriter fw = new FileWriter(new File(outputPath_attributes));
		fw.write(String.valueOf(0.30) + "\n");
		for( int i = 0; i < trainingData_noNameBond.numAttributes(); i++) {
			Attribute oneAttribute = trainingData_noNameBond.attribute(i);
			fw.write(oneAttribute.name() + "\n");
		}
		fw.close();
		Instances test_raw = getInstances(molecules_test);
		Instances test = this.pc.getSameAttributes(test_raw, trainingData_noNameBond);
		for(int j = 0; j < test.numInstances(); j++) {
			//System.out.println();
			double result = test.get(j).classValue();
			//double pred = rf.classifyInstance(testingData_noNameBond.get(j));
			double prob = rf.distributionForInstance(test.get(j))[1];
			double pred = 0.0;
			if(prob >= 0.30) pred = 1.0;
			if(result == pred) {
				if(result == 1.0) TP++;
				else TN++;
			}
			else {
				if(result == 1.0) {
					FN++;
				}
				else FP++;
			}
		}
		System.out.println("   P		N");
		System.out.println("P " + TP + "	   " + FN);
		System.out.println("N " + FP + "	   " + TN);
	}
	
	public void validate_SULT() throws Exception{
		String inputPath_allFeatures = "G:/PhaseIIPredictor/Sulfation/withNS/trainingFeatures.csv";
		String input_sdfPath = "G:/PhaseIIPredictor/Sulfation/withNS/Sulfation_validation.sdf";
		String outputPath = "G:/PhaseIIPredictor/Sulfation/checkFN_validate.csv";
		FileWriter fw = new FileWriter(new File(outputPath));
		fw.write("name,bond,prob\n");
		int bachPercent = 80;
		int threshold = 70;
		Trainmodel tm = new Trainmodel();
		int TP = 0, FP = 0, TN = 0, FN = 0;
		IAtomContainerSet molecules = 	this.cd.readSDFFile(input_sdfPath);
		Instances validInstances = getInstances(molecules);
		Instances allInstances = tm.pc.readCsv(inputPath_allFeatures);
		Instances trainingData_noNameBond = Utilities.selectByInfoGain(this.pc.getDatasetWithoutNameBond(allInstances), threshold);	
		Instances validateData_noNameBond = this.pc.getSameAttributes(validInstances, trainingData_noNameBond);
		
		
		RandomForest rf = new RandomForest();		
		rf.setBagSizePercent(bachPercent);
		rf.buildClassifier(trainingData_noNameBond);
		for(int j = 0; j < validateData_noNameBond.size(); j++) {
			//System.out.println();
			double result = validateData_noNameBond.get(j).classValue();
			//double pred = rf.classifyInstance(testingData_noNameBond.get(j));
			double prob = rf.distributionForInstance(validateData_noNameBond.get(j))[1];
			double pred = 0.0;
			if(prob >= 0.38) pred = 1.0;
			if(result == pred) {
				if(result == 1.0) TP++;
				else TN++;
			}
			else {
				if(result == 1.0) {
					fw.write(validInstances.instance(j).stringValue(0) + "," + validInstances.instance(j).stringValue(1) + "," + prob + "\n");
					FN++;
				}
				else FP++;
			}
		}
		fw.close();
		System.out.println("   P		N");
		System.out.println("P " + TP + "	   " + FN);
		System.out.println("N " + FP + "	   " + TN);
	}
	
	public void test_SULT() throws Exception{
		String inputPath_allFeatures = "G:/PhaseIIPredictor/Sulfation/withNS/trainingFeatures.csv";
		String input_validationPath = "G:/PhaseIIPredictor/Sulfation/withNS/Sulfation_validation.sdf";
		String test_sdfPath = "G:/PhaseIIPredictor/Sulfation/withNS/Sulfation_test.sdf";
		String outputPath = "G:/PhaseIIPredictor/Sulfation/checkFN_validate.csv";
		FileWriter fw = new FileWriter(new File(outputPath));
		fw.write("name,bond,prob\n");
		int bachPercent = 80;
		int threshold = 70;
		Trainmodel tm = new Trainmodel();
		int TP = 0, FP = 0, TN = 0, FN = 0;
		IAtomContainerSet molecules = 	this.cd.readSDFFile(input_validationPath);
		Instances validInstances = getInstances(molecules);
		Instances allInstances = tm.pc.readCsv(inputPath_allFeatures);
		Instances trainingData_noNameBond = Utilities.selectByInfoGain(this.pc.getDatasetWithoutNameBond(allInstances), threshold);	
		Instances validateData_noNameBond = this.pc.getSameAttributes(validInstances, trainingData_noNameBond);
		trainingData_noNameBond.addAll(validateData_noNameBond);
		
		IAtomContainerSet testMolecules = this.cd.readSDFFile(test_sdfPath);
		Instances testInstances = getInstances(testMolecules);
		Instances testingData_noNameBond = this.pc.getSameAttributes(testInstances, trainingData_noNameBond);
		
		RandomForest rf = new RandomForest();		
		rf.setBagSizePercent(bachPercent);
		rf.buildClassifier(trainingData_noNameBond);
		for(int j = 0; j < testingData_noNameBond.size(); j++) {
			//System.out.println();
			double result = testingData_noNameBond.get(j).classValue();
			//double pred = rf.classifyInstance(testingData_noNameBond.get(j));
			double prob = rf.distributionForInstance(testingData_noNameBond.get(j))[1];
			double pred = 0.0;
			if(prob >= 0.30) pred = 1.0;
			if(result == 1) {
				fw.write(testInstances.instance(j).stringValue(0) + "," + testInstances.instance(j).stringValue(1) + "," + prob + "\n");
			}
			if(result == pred) {
				if(result == 1.0) TP++;
				else TN++;
			}
			else {
				//result == 1.0 && pred == 0.0
				if(result == 1.0) {
					FN++;
				}
				else FP++;
			}
		}
		fw.close();
		System.out.println("   P		N");
		System.out.println("P " + TP + "	   " + FN);
		System.out.println("N " + FP + "	   " + TN);
	}
	
	public void test(String inputPath_allFeatures, String input_validationPath, String test_sdfPath) throws Exception{
		String outputPath_result = "G:/PhaseIIPredictor/UGT/withNS/UGT_predictedResults.csv";
		FileWriter fw_result = new FileWriter(new File(outputPath_result));
		String outputPath = "G:/PhaseIIPredictor/checkFN_validate.csv";
		FileWriter fw = new FileWriter(new File(outputPath));
		fw_result.write("smiles,bond,groutruth,predicted\n");
		fw.write("name,bond,prob\n");
		int bachPercent = 80;
		int threshold = 70;
		Trainmodel tm = new Trainmodel();
		int TP = 0, FP = 0, TN = 0, FN = 0;
		IAtomContainerSet molecules = 	this.cd.readSDFFile(input_validationPath);
		Instances validInstances = getInstances(molecules);
		Instances allInstances = tm.pc.readCsv(inputPath_allFeatures);
		Instances trainingData_noNameBond = Utilities.selectByInfoGain(this.pc.getDatasetWithoutNameBond(allInstances), threshold);	
		Instances validateData_noNameBond = this.pc.getSameAttributes(validInstances, trainingData_noNameBond);
		trainingData_noNameBond.addAll(validateData_noNameBond);
		
		IAtomContainerSet testMolecules = this.cd.readSDFFile(test_sdfPath);
		Instances testInstances = getInstances(testMolecules);
		Instances testingData_noNameBond = this.pc.getSameAttributes(testInstances, trainingData_noNameBond);
		
		RandomForest rf = new RandomForest();		
		rf.setBagSizePercent(bachPercent);
		rf.buildClassifier(trainingData_noNameBond);
		for(int j = 0; j < testingData_noNameBond.size(); j++) {
			//System.out.println();
			String smiles = testInstances.get(j).stringValue(0);
			String bond = testInstances.get(j).stringValue(1);
			
			double result = testingData_noNameBond.get(j).classValue();
			//double pred = rf.classifyInstance(testingData_noNameBond.get(j));
			double prob = rf.distributionForInstance(testingData_noNameBond.get(j))[1];
			double pred = 0.0;
			if(prob >= 0.30) pred = 1.0;
			if(result == 1) {
				fw.write(testInstances.instance(j).stringValue(0) + "," + testInstances.instance(j).stringValue(1) + "," + prob + "\n");
			}
			if(result == pred) {
				if(result == 1.0) TP++;
				else TN++;
			}
			else {
				//result == 1.0 && pred == 0.0
				if(result == 1.0) {
					FN++;
				}
				else FP++;
			}
			String oneResultLine = smiles + "," + "<" + bond + ">" + "," + result + "," + pred;
			fw_result.write(oneResultLine + "\n");
		}
		fw.close();
		System.out.println("   P		N");
		System.out.println("P " + TP + "	   " + FN);
		System.out.println("N " + FP + "	   " + TN);
	}
	
	
	public void validate(String inputPath_allFeatures, String input_sdfPath) throws Exception{
		String outputPath = "G:/PhaseIIPredictor/checkFN_validate.csv";
		FileWriter fw = new FileWriter(new File(outputPath));
		fw.write("name,bond,prob\n");
		int bachPercent = 80;
		int threshold = 70;
		Trainmodel tm = new Trainmodel();
		int TP = 0, FP = 0, TN = 0, FN = 0;
		IAtomContainerSet molecules = 	this.cd.readSDFFile(input_sdfPath);
		Instances validInstances = getInstances(molecules);
		Instances allInstances = tm.pc.readCsv(inputPath_allFeatures);
		Instances trainingData_noNameBond = Utilities.selectByInfoGain(this.pc.getDatasetWithoutNameBond(allInstances), threshold);	
		Instances validateData_noNameBond = this.pc.getSameAttributes(validInstances, trainingData_noNameBond);
		
		
		RandomForest rf = new RandomForest();		
		rf.setBagSizePercent(bachPercent);
		rf.buildClassifier(trainingData_noNameBond);
		for(int j = 0; j < validateData_noNameBond.size(); j++) {
			//System.out.println();
			double result = validateData_noNameBond.get(j).classValue();
			//double pred = rf.classifyInstance(testingData_noNameBond.get(j));
			double prob = rf.distributionForInstance(validateData_noNameBond.get(j))[1];
			double pred = 0.0;
			if(prob >= 0.35) pred = 1.0;
			if(result == pred) {
				if(result == 1.0) TP++;
				else TN++;
			}
			else {
				if(result == 1.0) {
					fw.write(validInstances.instance(j).stringValue(0) + "," + validInstances.instance(j).stringValue(1) + "," + prob + "\n");
					FN++;
				}
				else FP++;
			}
		}
		fw.close();
		System.out.println("   P		N");
		System.out.println("P " + TP + "	   " + FN);
		System.out.println("N " + FP + "	   " + TN);
	}
	
	public Instances getInstances(IAtomContainerSet molecules) throws Exception{
		String titleLine = GenerateTitleline.generateTitle(this.depth);	
		ArrayList<Attribute> attList = this.generateInstances.createAttributes(titleLine);		
		ArrayList<String> rawDataList = new ArrayList<>();
		Instances bomInstances = new Instances("Rel", attList, 100000); 
		
		for(int i = 0; i < molecules.getAtomContainerCount(); i++) {
			//if(i > 5) break;
			System.out.println("Finished molecule : " + (i+1));
			IAtomContainer oneMole = molecules.getAtomContainer(i);
			ArrayList<String> rawFeatureList = new ArrayList<>();
			try {
				rawFeatureList = this.generateRawFeatures.generateRawFeatures(oneMole);
			}catch (Exception e) {
				//e.printStackTrace();				
				System.out.println("Failed processing molecule " + (i-550 + 1) + ": " + cd.sg.create(oneMole));
				IAtomContainer converted = this.cd.processNitrogen(oneMole);
				if(converted == null || converted.isEmpty()) System.out.println("Failed to convert the nitrogen contained functional group");
				else{
					System.out.println("Converted: " + cd.sg.create(converted));
					try {
						rawFeatureList = this.generateRawFeatures.generateRawFeatures(converted);		
					}catch(Exception e2) {
						System.out.println("Failed to generate raw features for the converted structure");
						continue;
					}
				}
			}
			rawDataList.addAll(rawFeatureList);
			
		
		}
		bomInstances = this.generateInstances.createInstances(rawDataList, titleLine);
		return bomInstances;
	}
}
