package generateInstance;

import weka.filters.supervised.attribute.AttributeSelection;
import weka.attributeSelection.InfoGainAttributeEval;
import weka.attributeSelection.Ranker;
import weka.core.Instances;
import weka.filters.Filter;

public class RemoveUselessFeatures {
	/**
	 * This function is used to select a subset of features by using information gain algorithm
	 * Eg. Threshold = 50 means select the first 50 features whose information gain value is highest.
	 * @param dataset
	 * @param threshold: thedhold - 3 = the real number of features selected. Because class, name and bond are not considered as features.
	 * @return
	 * @throws Exception
	 */
	public static Instances selectByInfoGain(Instances dataset, int threshold) throws Exception{		
		AttributeSelection filter = new AttributeSelection();
		InfoGainAttributeEval infoGain = new InfoGainAttributeEval();
		Ranker ranker = new Ranker();
	    //System.out.println(newData.numAttributes());
	    /**
	     * Set number of attributes
	     */
	    ranker = new Ranker();
		//ranker.setNumToSelect(100);
		filter.setEvaluator(infoGain);
		//int numFeatures = dataset.numAttributes(); // Get the number of features 
		ranker.setNumToSelect(threshold);
		
		//ranker.getGenerateRanking();
		filter.setSearch(ranker);	
	    filter.setInputFormat(dataset);
	    Instances fianlNewData = Filter.useFilter(dataset, filter);
	    if(dataset.classIndex() == -1){
	    	dataset.setClassIndex(dataset.numAttributes()-1);
	    }
	    return fianlNewData;
	}
}
