package phase2utils;

import generateFeatures.BoMAtomFeatures;
import generateFeatures.FingerprintQueries;

public class GenerateTitleline {

	public static String generateTitle(int depth) throws Exception{
		StringBuffer titleLineBuffer = new StringBuffer();
		titleLineBuffer.append("Name" + "," + "Bond");
		/**
		 * Real Class Label
		 */
		titleLineBuffer.append(",").append("BoM");
		String[] molecularDescriptorTitle = {"ALOGP", "APol", "HBondAcceptorCount", "HBondDonorCount", "MomentOfInertia", "RotatableBondsCount",
				"TPSA", "Weight", "XLogP"};
		for(int i = 0; i < molecularDescriptorTitle.length; i++){
			titleLineBuffer.append("," + molecularDescriptorTitle[i]);
		}
		String atomHydrogenCount = "atomHydrogenCount";
		titleLineBuffer.append("," + atomHydrogenCount);
		String[] atomTypeTitle = BoMAtomFeatures.atomTypeLookupTable;
		for(int i = 0; i < atomTypeTitle.length; i++){
			titleLineBuffer.append("," + "Current_" + atomTypeTitle[i]);
		}
		String[] atomDescriptorTitle = {"AtomDegree", "AtomHybridization", "AtomValence", "EffectiveAtomPolarizability", "PartialSigmaCharge",
										"PartialTChargeMMFF94", "PiElectronegativity", "SigmaElectronegativity", "StabilizationPlusCharge"};
		for(int i = 0; i < atomDescriptorTitle.length; i++){
			titleLineBuffer.append("," + atomDescriptorTitle[i]);
		}
		for(int i = 0; i < 28; i++){
			titleLineBuffer.append("," + "d=1_environmentFeature_" + i);			
		}
		for(int i = 0; i < 28; i++){
			titleLineBuffer.append("," + "d=2_environmentFeature_" + i);			
		}
		for(int i = 0; i < 28; i++){
			titleLineBuffer.append("," + "d=3_environmentFeature_" + i);			
		}
		for(int i = 0; i < 28; i++){
			titleLineBuffer.append("," + "d=4_environmentFeature_" + i);			
		}
		for(int i = 0; i < FingerprintQueries.newQueriesList.size(); i++){
			titleLineBuffer.append("," + "closestAtomFP_" + i);		
		}
		for(int i = 0; i < atomTypeTitle.length; i++){
			titleLineBuffer.append("," + "closestAtomAtomType_" + atomTypeTitle[i]);
		}
		for(int d = 0; d < depth+1; d++){
			//System.out.println(ChemSearcher.getFingerprintPatterns().size());
			if(d== 0){
				for(int i = 0; i < FingerprintQueries.newQueriesList.size(); i++){//GeneratePatterns.queriesList.size() + 
					titleLineBuffer.append("," + "currentFP_" + i);
				}
			}
			else{
				for(int i = 0; i < FingerprintQueries.newQueriesList.size(); i++){
					titleLineBuffer.append("," + "d=" + d + "FP_" + i);
				}
			}
		}
		return titleLineBuffer.toString();
	}
}
